
#ifndef _COM_H_
  #define _COM_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  #define COM_110BAUDS 1040
  #define COM_150BAUDS 768
  #define COM_300BAUDS 384
  #define COM_600BAUDS 192
  #define COM_1200BAUDS 96
  #define COM_2400BAUDS 48
  #define COM_4800BAUDS 24
  #define COM_9600BAUDS 12
  #define COM_19200BAUDS 6
  #define COM_38400BAUDS 3
  #define COM_57600BAUDS 2
  #define COM_115200BAUDS 1

  #define COM_INTERRUPT_AUTODETECT -1

  #define COM_INITERR_PORT -1
  #define COM_INITERR_IRQ -2

  #define COM_COMMAND_NOTHING     0x00000000
  #define COM_COMMAND_LOGIN       0x50676f4c // LogP
  #define COM_COMMAND_LOGINMASTER 0x4d676f4c // LogM
  #define COM_COMMAND_LOGINSLAVE  0x53676f4c // LogS
  #define COM_COMMAND_LOGOUT      0x4f676f4c // LogO
  #define COM_COMMAND_ID          0x49676f4c // LogI

  #define COM_USER_NOTHING 0
  #define COM_USER_TEMP 1
  #define COM_USER_PEER 2
  #define COM_USER_MASTER 3
  #define COM_USER_SLAVE 4

  #define COM_NAME_MAXLEN 20

  extern short COM_portAddr [];
  extern int COM_irqInt [];
  extern int COM_irqNum [];

  extern int COM_port;
  extern int COM_addr;
  extern int COM_irq;
  extern int COM_int;
  extern long COM_baudSpeed;
  extern long COM_byteSpeed;

  extern long COM_command;
  extern int COM_user;

//  extern long COM_bytesReceived;
//  extern long COM_bytesSent;

  extern char COM_remoteName [COM_NAME_MAXLEN+1];
  extern char COM_localName [COM_NAME_MAXLEN+1];

  extern void COM_send (char *s, int dataSize);
  extern int COM_receive (char *s);
  extern int COM_setup (int port, int irq, int speed);
  extern void COM_restore (void);
  extern void COM_done (void);
  extern void COM_init (void);
  extern int COM_login (char *name, int (*waitHandler) (void) );
  extern int COM_create (char *name, int (*waitHandler) (void) );
  extern int COM_join (char *name, int (*waitHandler) (void) );
  extern void COM_logout (void);

  #ifdef __cplusplus
  }
  #endif

#endif
