
#include <stdio.h>
#include <dos.h>
#include <string.h>

#include "cgdk.h"
#include "ipxnet.h"
#include "ipxnets.h"
#include "timer.h"
#include "svga.h"
#include "file.h"
#include "tm.h"

#define SERVER_MODE 1
#define SETTINGS_MODE 2

typedef struct
{
  char server [80];
  char site [10];
} Textra;

unsigned short wordSwap (unsigned short swapThis)
{
  char *s = (char *) &swapThis;
  unsigned short result;
  char *r = (char *) &result;

  *r = *(s+1);
  *(r+1) = *s;
  return result;
}

int main (void)
{
  char node_adr [2*sizeof (TNodeAddr)+1];
  char net_adr [2*sizeof (TNetAddr)+1];
  TIPXAddress *MyAddress, extraa;
  Textra *extra = malloc (100 * sizeof (Textra));
  int extraCount=0;
  char s [256];
  char *s1, *s2, *s3;
  FILE *f;
  int mode=0;
  char *cfg;
  char cfgfull [200];
  char curdir [200];
  unsigned short socket;
  int i;

  printf ("\nICHAT - IPX Chat Program, version 1.0\n"
          "%s\n","Copyright (C) 1998 Marek \"Zanzag\" Gayer, xgayer@fel.cvut.cz\n");

  if (extra == NULL)
  {
    CGDK_exit ("Not enough memory.\n", 3);
  }

  SVGA_enableVESA = 0;
  CGDK_init ();
  TIMER_init (TIMER_OLDFREQ_DEF);

  if ((SVGA_compatible & VGA_COMPATIBLE) == 0)
  {
    CGDK_exit ("This program requires a VGA compatible videocard.\n", 4);
  }


  F_getFullPath (cfgfull, "ICHAT.CFG");
  if (!F_exist (cfgfull))
  {
    F_getExecPath (cfgfull, "ICHAT.CFG");
    if (!F_exist (cfgfull))
    {
      cfg = NULL;
    }
    else
      cfg = cfgfull;
  }
  else
  {
    cfg = cfgfull;
  }
  if (cfg)
  {
    if (cfg [2] == cfg [3] == '\\')
    {
      strcpy (cfg+2, cfg+3);
    }
    printf ("Using configuration file %s\n\n", cfg);

    f = fopen (cfg, "rt");
    if (f == NULL)
    {
      sprintf (exitStr, "Error opening %s\n", cfg);
      CGDK_exit (exitStr, 2);
    }
    else
    {

      while (fgets (s, 255, f) == s)
      {
        s1 = s;
        while (*s1 == ' ')
          s1++;
        if ((*s1 != ';') && (*s1 != '\n') && (*s1 != '\r'))
        {
          if (*s1 == '[')
          {
            s1++;
            s2 = strchr (s1, ']');
            if (s2)
            {
              *s2 = 0;
              while (*s1 == ' ') s1++;
              if (strnicmp (s1, "networks", strlen ("networks")-1) == 0)
                mode = SERVER_MODE;
              if (strnicmp (s1, "settings", strlen ("settings")-1) == 0)
                mode = SETTINGS_MODE;
            }
          }
          else
          {
            if (mode == SERVER_MODE)
            {
              s2 = strchr (s1, '=');
              if (s2 != NULL)
              {
                *s2 = 0;
                s2++;
                while (*s2 == ' ') s2++;
                s3 = strchr (s2, '\n');
                if (s3) *s3 = 0;
                s3 = s1;
                if (s3 = strchr (s3, ' '), s3 != NULL)
                {
                  *s3 = 0;
                }
                strncpy (extra [extraCount].server, s1, 49);
                strncpy (extra [extraCount].site, s2, 9);
                extraCount++;
              }
            }
            if (mode == SETTINGS_MODE)
            {
              s2 = strchr (s1, '=');
              if (s2 != NULL)
              {
                *s2 = 0;
                s2++;
                while (*s2 == ' ') s2++;
                s3 = strchr (s2, '\n');
                if (s3) *s3 = 0;
                s3 = s1;
                if (s3 = strchr (s3, ' '), s3 != NULL)
                {
                  *s3 = 0;
                }
                if ((stricmp (s1, "socket") == 0) && (*s2 != 0))
                {
                  NODE_scansSocketAddress (&extraa, s2);
                  IPX_socket = extraa.Socket;
                  socket = wordSwap (extraa.Socket);
                }
              }

            }
          }
        }
      }
      fclose (f);
    }
  }
  else
  {
    printf ("ICHAT.CFG file not found, using default settings.\n");
  }

  if (NET_Init ())
  {
    MyAddress = NODE_GetLocalAddress ();
    NODE_printsNetAddress (MyAddress, net_adr);
    NODE_printsNodeAddress (MyAddress, node_adr);
    printf ("Local machine address is network=%s:node=%s, socket=%x\n\n", net_adr, node_adr, socket);

    for (i = 0; i < extraCount; i++)
    {
      printf ("Connecting to %s network (%s)", extra [i].server, extra [i].site);
      NODE_scansNetAddress (&extraa, extra [i].site);
      if (NODE_addExtraServer (&extraa.Network) == 0)
      {
        printf (", OK.\n");
      }
      else
      {
        printf (", failed.\n");
      }
    }

    free (extra);

    TM_setup ();

    NETS_Setup ();

    NET_Done ();
  }
  else
  {
    CGDK_exit ("An IPX compatible network has been not found.\n", 1);
  }

  return 0;
}
