
#ifndef _SVGA_H_
#define _SVGA_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  #include <stdlib.h>

  #include "vga.h"
  #include "xvga.h"
  #include "vesa.h"

  #define SVGA_SETMODE_OK 0
  #define SVGA_SETMODE_NOTCOMPATIBLE 1
  #define SVGA_SETMODE_NOSUPPORT 2
  #define SVGA_SETMODE_NOHICOLORSUPPORT 3
  #define SVGA_SETMODE_OUTOFMEMORY 4

  #define PAL_6BIT 6
  #define PAL_8BIT 8

  #define LINEAR_FRAME_BUFFER 0x4000

  #define P_SPR 0
  #define P_WIN 1
//  #define P_RAW 2
//  #define P_FORMAT 4

  #define DOUBLE_BUFFER 0x2000

  #define NOT_COMPATIBLE 0
  #define VGA_COMPATIBLE 1
  #define VESA_COMPATIBLE 2

  #define VMODE_LINEAR 1
  #define VMODE_SCROLL 2
  #define VMODE_ANY 0

//  extern int SVGA_VESA12_mode;
  extern int SVGA_enableVESA;
  extern int SVGA_virtualX;
  extern int SVGA_virtualY;
  extern long SVGA_virtualPool;
  extern int SVGA_virtualXD2;
  extern int SVGA_virtualYD2;
  extern long SVGA_virtual;
  extern long SVGA_virtual2;
  extern long SVGA_virtualD4;
  extern int SVGA_scanLines;
  extern int SVGA_compatible;
  extern int SVGA_maxX;
  extern int SVGA_maxY;
  extern long SVGA_max;
  extern int SVGA_curX;
  extern int SVGA_curY;
  extern int SVGA_curXNext;
  extern int SVGA_curYNext;
  extern int SVGA_curXPrev;
  extern int SVGA_curYPrev;
  extern int SVGA_graph;
  extern int SVGA_maxXPlus;
  extern int SVGA_maxYPlus;
  extern double SVGA_freq;

  extern int SVGA_dx;
  extern int SVGA_dy;

  extern int SVGA_doubleBuffer;
  extern int SVGA_videoMode;

  extern int SVGA_bytesPerPixel;
  extern int SVGA_bitsPerPixel;
  extern int SVGA_palType;
  extern void far *SVGA_linearBuf;
  extern int SVGA_linearSeg;
  extern void *SVGA_linearOff;
  extern void *SVGA_linearOff2;

  extern void SVGA_virtual2Real (int *X, int *Y);
  extern void SVGA_virtual2RealDelta (int *dx, int *dy);
  extern void SVGA_updateCurPos (int X, int Y);
  extern void SVGA_syncCurPos (void);
  extern long SVGA_setBankCount;
//  extern void SVGA_exchangeNextCurPos (void);

  extern void (*SVGA_scroll) (void);

//  extern int SVGA_init (void);
  extern int SVGA_getModeInfo (int Mode, int *XRes, int *YRes,
                          int *BytesPerLine,int *BitsPerPixel);
  extern int SVGA_setVideoMode (int VideoMode); // = NULL, = NULL, = NULL, = NULL
  extern void SVGA_setDefaultMode (void);
  extern int SVGA_switchDefaultMode (void);
  extern int SVGA_videoModeSupported (int VideoMode);
  extern void SVGA_done (void);
  extern void SVGA_restoreVideoMode (void);

  extern void (*SVGA_clear_) (long Color);
  extern void SVGA_clear (long Color);

  extern void (*SVGA_setBank) (int bank);

  extern void (*SVGA_putWin_) (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX);
  extern void (*SVGA_putSpr_) (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX);

  extern void (*SVGA_getWin_) (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX);

//  extern void (*SVGA_movSpr_) (void *Win, int X, int Y, int Size_X, int Size_Y, int formatX);
//  extern void (*SVGA_movWin_) (void *Win, int X, int Y, int Size_X, int Size_Y, int formatX);
//  extern void (*SVGA_putBorder_) (void *Win, int X, int Y, int Size_X, int Size_Y, int formatX);
//  extern void (*SVGA_get_) (void *Spr, int X, int Y, int Size_X, int Size_Y, int formatX);
//  extern void (*SVGA_cflush) (void);
//  extern void (*SVGA_cdone) (void);
//  extern void (*SVGA_movPixel_) (int X, int Y, long Pixel);
  extern long (*SVGA_getPixel_) (int X, int Y);

  extern int SVGA_recommendVideoMode (int sizeX, int sizeY,
				      int bytesPerPixel,
				      int type); // = 1, = VMODE_ANY

//  extern void SVGA_clear (long Color); // = 0, = 1

//  extern void SVGA_movPixel (int X, int Y, long Pixel); // = 1
  extern void SVGA_putPixel (int X, int Y, long Pixel); // = 1
  extern long SVGA_getPixel (int X, int Y); // = 1

  extern void SVGA_getWin (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX); // = 0, = 1
  extern void SVGA_putWin (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX); // = 0, = 1
  extern void SVGA_putSpr (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX); // = 0, = 1
//  extern void SVGA_movWin (void *Sprite,int X,int Y,
//                           int Size_X, int Size_Y, int formatX); // = 0, = 1
//  extern void SVGA_movSpr (void *Sprite,int X,int Y,
//                           int Size_X, int Size_Y, int formatX); // = 0, = 1

  extern void SVGA_clearNoVSB (long Color); // = 0, = 1

  extern void SVGA_putPixelNoVSB (int X, int Y, long Pixel); // = 1
//  extern void SVGA_movPixelNoVSB (int X, int Y, long Pixel); // = 1
  extern long SVGA_getPixelNoVSB (int X, int Y); // = 1

  extern void SVGA_getWinNoVSB (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX); // = 0, = 1
//  extern void SVGA_movWinNoVSB (void *Sprite,int X,int Y,
//			   int Size_X, int Size_Y, int formatX); // = 0, = 1
//  extern void SVGA_movSprNoVSB (void *Sprite,int X,int Y,
//			   int Size_X, int Size_Y, int formatX); // = 0, = 1
  extern void SVGA_putWinNoVSB (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX); // = 0, = 1
  extern void SVGA_putSprNoVSB (void *Sprite,int X,int Y,
			   int Size_X, int Size_Y, int formatX); // = 0, = 1

//  #define SVGA_putSpr(win,x,y,sizeX,sizeY) SVGA_put(win,x,y,sizeX,sizeY,P_SPR|P_FORMAT)
//  #define SVGA_putWin(win,x,y,sizeX,sizeY) SVGA_put(win,x,y,sizeX,sizeY,P_WIN|P_FORMAT)
//  #define SVGA_getWin(win,x,y,sizeX,sizeY) SVGA_get(win,x,y,sizeX,sizeY,P_WIN|P_FORMAT)

  extern void SVGA_putChar (int x,int y,unsigned char c,long color);
  extern void SVGA_putStr (int x,int y,char *str,long color);
  extern void SVGA_getStr (int x, int y, char *str, long color, long backColor); // = 0
  extern void SVGA_clearScreen (void);
  extern void SVGA_update (int n); // = 1
  extern void SVGA_flush (void);

  extern void SVGA_retraceInit (void);

  extern int SVGA_enableRetrace;
/*  extern void SVGA_retraceStart (void);
  extern void SVGA_retraceEnd (void);
  extern void SVGA_waitVerticalRetrace (int count);
  extern void SVGA_wait (int count);
  extern void SVGA_waitRevert (int count);

  extern int SVGA_returnVideoMode (void);
  extern int SVGA_switchVideoMode (int Mode); */

  #include "svgac_.h"

  #ifdef __cplusplus
  }
  #endif

#endif
